module     p0_dubar_emnebarg_d10h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm1jet/1.4/Virtual/
   ! p0_dubar_emnebarg/helicity0/d10h0l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarg_config, only: ki
   use p0_dubar_emnebarg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarg_groups, only: &
!           & sign => diagram10_sign, shift => diagram10_shift
      use p0_dubar_emnebarg_globalsl1, only: epspow
      use p0_dubar_emnebarg_kinematics
      use p0_dubar_emnebarg_abbrevh0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d10
      complex(ki) :: t1
      complex(ki) :: t2

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d10 = 0.0_ki
      t1 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      d10 = (abb10n3+t1*abb10n2+t2*abb10n5+abb10n4*(Q(1)*spvak2k1(1)-Q(2)*spvak2&
      &k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+abb10n6*(Q(1)*spvak1k5(1)-Q(2)*s&
      &pvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4))+abb10n8*(Q(1)*Q(1)-Q(2)*Q(2&
      &)-Q(3)*Q(3)-Q(4)*Q(4))+abb10n9*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(&
      &4))+t1*t2*abb10n7+t1*abb10n10*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spv&
      &ak5k1(3)-Q(4)*spvak5k1(4)))
      numerator = cmplx(real(d10, ki), aimag(d10), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarg_globalsl1, only: epspow
      use p0_dubar_emnebarg_kinematics
      use p0_dubar_emnebarg_abbrevh0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d10
      complex(ki) :: t1
      complex(ki) :: t2

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d10 = 0.0_ki
      t1 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      d10 = (abb10n3+t1*abb10n2+t2*abb10n5+abb10n4*(Q(1)*spvak2k1(1)-Q(2)*spvak2&
      &k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+abb10n6*(Q(1)*spvak1k5(1)-Q(2)*s&
      &pvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4))+abb10n8*(Q(1)*Q(1)-Q(2)*Q(2&
      &)-Q(3)*Q(3)-Q(4)*Q(4))+abb10n9*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(&
      &4))+t1*t2*abb10n7+t1*abb10n10*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spv&
      &ak5k1(3)-Q(4)*spvak5k1(4)))

      numerator = cmplx(real(d10, ki), aimag(d10), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarg_d10h0l1
