module     p0_dubar_emnebarg_d8h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wm1jet/1.4/Virtual/
   ! p0_dubar_emnebarg/helicity0/d8h0l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarg_config, only: ki
   use p0_dubar_emnebarg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarg_groups, only: &
!           & sign => diagram8_sign, shift => diagram8_shift
      use p0_dubar_emnebarg_globalsl1, only: epspow
      use p0_dubar_emnebarg_kinematics
      use p0_dubar_emnebarg_abbrevh0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d8
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d8 = 0.0_ki
      t1 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      d8 = (t1*abb8n2+t1*t1*abb8n1+t1*abb8n3*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q&
      &(4)*k5(4))+t1*abb8n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+t1*abb&
      &8n5*(Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))&
      &+t1*abb8n6*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak&
      &3k1(4)))
      numerator = cmplx(real(d8, ki), aimag(d8), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarg_globalsl1, only: epspow
      use p0_dubar_emnebarg_kinematics
      use p0_dubar_emnebarg_abbrevh0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d8
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d8 = 0.0_ki
      t1 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))
      d8 = (t1*abb8n2+t1*t1*abb8n1+t1*abb8n3*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q&
      &(4)*k5(4))+t1*abb8n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+t1*abb&
      &8n5*(Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))&
      &+t1*abb8n6*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak&
      &3k1(4)))

      numerator = cmplx(real(d8, ki), aimag(d8), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarg_d8h0l1
